package com.caimei365.user.mapper;

import com.caimei365.user.model.po.SuperVipPo;
import com.caimei365.user.model.po.VipPayHistoryPo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * @author zzj
 */
@Mapper
public interface SuperVipMapper {

    /**
     * 查vip信息
     *
     * @param userId
     * @return
     */
    SuperVipPo findSuperVip(Integer userId);

    /**
     * 查用户名下采美豆余额
     *
     * @param userId
     * @return
     */
    Integer findUserBeans(Integer userId);

    /**
     * user表修改采美豆数量
     *
     * @param userId
     * @param userBeans
     */
    void updateUserBeans(Integer userId, Integer userBeans);

    /**
     * 采美豆历史表更改
     *
     * @param userId
     * @param userBeans
     */
    void updateUserBeansHistory(Integer userId, Integer userBeans);

    /**
     * 用户权限修改
     * 用户权限 0游客 1 普通用户 2 会员机构 3 供应商 4 协销 5 普通机构 6 呵呵商城用户【V6.2.0版本后0和1不存在】
     *
     * @param userId
     * @param userPermission
     */
    void updateUserPermission(Integer userId, Integer userPermission);

    /**
     * 用户身份修改
     * 用户身份 0、个人 1、协销 2、会员机构 3、供应商 4.普通机构 6、呵呵商城用户【V6.2.0版本后0不存在】
     *
     * @param userId
     * @param userIdentity
     */
    void updateUserIdentity(Integer userId, Integer userIdentity);

    /**
     * 查买的套餐的现金价格
     *
     * @param userPackageId
     * @return
     */
    Double findUserPackage(Integer userPackageId);

    /**
     * 新增支付记录
     *
     * @param payHistory
     */
    void addPayHistory(VipPayHistoryPo payHistory);

    /**
     * 根据套餐id查套餐时间
     *
     * @param userPackageId
     * @return
     */
    Integer findUserPackageTime(Integer userPackageId);

    /**
     * 超级会员表加数据
     * @param superVip
     */
    void addVip(SuperVipPo superVip);

    /**
     * 修改超级会员表
     * @param superVip
     */
    void updateVip(SuperVipPo superVip);

    /**
     * 查超级会员购买记录
     * @param userId
     * @return
     */
    List<VipPayHistoryPo> findVipHistory(@Param("userId") Integer userId);

    /**
     * 查会员是否过期
     * @param userId
     * @return
     */
    SuperVipPo findEndTime(Integer userId);
}
